routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();
//Route::post('/schedule', 'ScheduleController@store')->name('schedule.store');

Route::resource('course','CourseController');
Route::resource('schedule','ScheduleController')->middleware('isStudent');
Route::view('/course/create', 'create_course')->middleware('isAdmin');
//Route::view('/course', 'index_course');

//->middleware('auth');

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/welcome','HomeController@welcome')->name('welcome');
//Route::get('/course/create','HomeController@create_course')->name('create');

app/Course.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Course extends Model
{
    

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'credit', 
    ];

   
    
}

app/Schedule.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Schedule extends Model
{
    protected $table = 'schedule';
    protected $fillable = [
        'user_id', 'course_id', 
    ];
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email','role', 'password', 
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/CourseController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Course;

class CourseController extends Controller
{
    
    protected $table = 'unime';
    public function index()
    {
        $data= Course::latest()->paginate(5);
        return view('index_course', compact('data'))
        -> with ('i', (request()->input('page',1)-1) * 5);
    
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('create_course');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
         //validate
        $request->validate ( [
            'name' => 'required| string| max:255',
            'credit' => ['required'],

        ]);
        
        $form_data = array(
            'name'  => $request->name,
            'credit'   => $request->credit
            

        );
        Course::create($form_data);
        return redirect('course')->with('success', 'Data Added successfully.');


    }



    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $data = Course::findOrFail($id);
        return view('view_course', compact('data'));
    }
    

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
    public function welcome(Request $req){
        return view('welcome');
    }
    //public function create_course(Request $req){
      //  return view('create_course');
    //}

    


}

app/Http/Controllers/ScheduleController.php
<?php

namespace App\Http\Controllers;
use App\Schedule;
use Illuminate\Http\Request;

class ScheduleController extends Controller
{
    protected $table = 'unime';
    public function index()
    {
        $id= auth()->user()->id;
        $data = Schedule::
        //
        where('user_id', $id )->get();;
        //$data= Schedule::latest()->paginate(5);
        return view('index_schedule', compact('data'));
       // -> with ('i', (request()->input('page',1)-1) * 5);
    
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('create_schedule');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        
        
        $request->validate ( [
            'course_id' => 'required'
        ]);
      
        $form_data = array(
            'course_id'   => $request->course_id,
            'user_id'  =>  $request->user_id ,
            
        );

        $rec = Schedule::where('course_id', $request->course_id)->where( 'user_id', $request->user_id)->first();
            if ($rec === null) {
                Schedule::create($form_data);
                return redirect('course')->with('success', 'Registered successfully.');
            }
        //Schedule::create($form_data);
        return redirect('course')->with('success', 'Already Registered !');


    }


    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/create_course.blade.php
@extends('parent')

@section('main')
@if($errors->any())

<div class="alert alert-danger">
    <ul>
        @foreach ($errors->all() as $error)
        <li> {{ $error }} </li>
        @endforeach

    </ul>
</div>
@endif

<div align="right">
    <a href="{{ route('course.index')}}"> Back </a>
</div>


<form method="post" action="{{ route('course.store')}}" enctype="multipart/form-data">
    @csrf
    <div>
    <label> Enter Course Name </label>
        <div>
            <input type="text" name="name" />
        </div>
    </div>

    <br/>
    <br/>

    <div>
    <label> Enter Credit Hours </label>
        <div>
            <input type="text" name="credit" />
        </div>
    </div>

    <br/>
    <br/>

    <div>
        <input type="submit" name="add" />  
    </div>

</form>
    
@endsection

resources/views/create_schedule.blade.php
@extends('parent')

@section('main')
@if($errors->any())

<div class="alert alert-danger">
    <ul>
        @foreach ($errors->all() as $error)
        <li> {{ $error }} </li>
        @endforeach

    </ul>
</div>
@endif

<div align="right">
    <a href="{{ route('course.index')}}"> Back </a>
</div>


<form method="post" action="{{ route('schedule.store')}}" enctype="multipart/form-data">
    @csrf
    <div>
    <label> Enter User ID </label>
        <div>
            <input type="text" name="user_id" />
        </div>
    </div>

    <br/>
    <br/>

    <div>
    <label> Enter Course ID </label>
        <div>
            <input type="text" name="course_id" />
        </div>
    </div>

    <br/>
    <br/>

    <div>
        <input type="submit" name="add" />  
    </div>

</form>
    
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
<div >
<a href="{{ url('/welcome') }}" style="margin-left:10%;">back</a>
</div>
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card" style="background-color:pink;">
                <div class="card-header" style="background-color:grey;">Dashboard</div>

                <div class="card-body" style="margin-left:45%">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    Welcome !
                </div>

                <div class="panel-body" style="margin-left: 25%;  width: 70%;">
            
                    <tr>
                        <td> <p> Role: <strong>{{ Auth::user()->role }}</strong> </p></td>
                        <td><p> Name: <strong>{{ Auth::user()->name }}</strong></p> </td>
                        <td><p> Email: <strong>{{ Auth::user()->email }}</strong></p> </td>
                    </tr>
                
                
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/index_course.blade.php
@extends('parent')

@section('main')


<div align="left">
<a href="{{ url('/welcome') }}">Back</a>
</div>


@if($message = Session::get('success'))
<div class="alert alert-success">
    <p>{{ $message }}</p>
</div>
@endif





<table class="table table-bordered table-striped">
    <tr>
      
        <th width="40%"> Course Name </th>
        <th width="40%"> Credit Hours </th>
        <th width="20%"> Actions </th>
        
    </tr>
    @foreach($data as $row)
    
    <tr>
        <td>{{ $row->name }}</td>
        <td>{{ $row->credit }}</td>
        <td>
            <div>
           
                <a href="{{route('course.show', $row->id )}}">Show</a>
                <form action= "{{ route('schedule.store')}}" method="post">
                @csrf
                    <input type="hidden" name="user_id" value="{{ auth()->user()->id }}"> 
                    <input type="hidden" name="course_id" value="{{ $row->id }}"> 
                    <input type="submit" name="register" value="register">
                </form>
                
            </div>
        </td>

    </tr>
  

    @endforeach
</table>
{!! $data->links()!!}
@endsection

resources/views/index_schedule.blade.php
@extends('parent')

@section('main')


<div align="left">
<a href="{{ url('/welcome') }}">Back</a>
</div>


@if($message = Session::get('success'))
<div class="alert alert-success">
    <p>{{ $message }}</p>
</div>
@endif





<table class="table table-bordered table-striped">
    <tr>
        <th width="8%"> User Id </th>
        <th width="32%"> User Name </th>
        <th width="8%"> Course Id </th>
        <th width="32%"> Course Name </th>
        <th width="20%"> Course Credit Hours </th>
        
        
        
    </tr>
    @foreach($data as $row)
    <tr>
        <td>{{ $row->user_id }}</td>
        <td> {{auth()->user()->name}} </td>
        <td>{{ $row->course_id }}</td>
        <td> {{ App\Course::where('id', $row->course_id )->first()->name}}</td>
        <td>{{App\Course::where('id', $row->course_id )->first()->credit}} </td>
        

    </tr>

    @endforeach
</table>

@endsection

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/parent.blade.php
<html>
<head>
    <meta name="viewport" content="width=device-width,initial-scale=1"/>
    <title> unime </title>
    <meta name="viewport" content="width=device-width,initial-scale=1,maximum-scale=1"/>
    <script>src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/css/bootstrap.min.css">

</head>

<body>
    <div class="container">
        <br/>
        <h3 align="center" > UniMe</h3>
        <br />
        @yield('main')
    </div>
</body>

</html>

resources/views/view_course.blade.php
@extends('parent')

@section('main')

<div class="jumbotron text-center">
    <div align="right">
        <a href="{{route('course.index')}}"> Back</a>
    </div>
</div>
<br>
<h3> Course Id - {{$data->id}} </h3>
<h3> Course Name - {{$data->name}} </h3>
<h3> Course Credit - {{$data->credit}} </h3>



@endsection